config/routes.rb
Rails.application.routes.draw do
  resources :lists do
    resources :tasks
  end
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root to: "lists#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/list.rb
class List < ApplicationRecord
  has_many :tasks
end

app/models/task.rb
class Task < ApplicationRecord
  belongs_to :list
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/lists_controller.rb
class ListsController < ApplicationController
  before_action :set_list, only: %i[ show edit update destroy ]

  # GET /lists or /lists.json
  def index
    @lists = List.all
  end

  # GET /lists/1 or /lists/1.json
  def show
    @tasks = @list.tasks
  end

  # GET /lists/new
  def new
    @list = List.new
  end

  # GET /lists/1/edit
  def edit
  end

  # POST /lists or /lists.json
  def create
    @list = List.new(list_params)

    respond_to do |format|
      if @list.save
        format.html { redirect_to @list, notice: "List was successfully created." }
        format.json { render :show, status: :created, location: @list }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @list.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /lists/1 or /lists/1.json
  def update
    respond_to do |format|
      if @list.update(list_params)
        format.html { redirect_to @list, notice: "List was successfully updated." }
        format.json { render :show, status: :ok, location: @list }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @list.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /lists/1 or /lists/1.json
  def destroy
    @list.destroy
    respond_to do |format|
      format.html { redirect_to lists_url, notice: "List was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_list
      @list = List.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def list_params
      params.require(:list).permit(:name)
    end
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  before_action :set_task, only: %i[ show edit update destroy ]
  before_action :set_list

  # GET /tasks or /tasks.json
  def index
    @tasks = Task.all
  end

  # GET /tasks/1 or /tasks/1.json
  def show
    @tasks = set_task
  end

  # GET /tasks/new
  def new
    @task = Task.new(list: @list)
  end

  # GET /tasks/1/edit
  def edit
  end

  # POST /tasks or /tasks.json
  def create
    @task = Task.new(task_params)
    @task.list = @list

    respond_to do |format|
      if @task.save
        format.html { redirect_to @list, notice: "Task was successfully created." }
        format.json { render :show, status: :created, location: @task }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tasks/1 or /tasks/1.json
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to @list, notice: "Task was successfully updated." }
        format.json { render :show, status: :ok, location: @task }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1 or /tasks/1.json
  def destroy
    @task.destroy
    respond_to do |format|
      format.html { redirect_to list_tasks_url, notice: "Task was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_task
      @task = Task.find(params[:id])
    end

    def set_list
      @list = List.find(params[:list_id])
    end

    # Only allow a list of trusted parameters through.
    def task_params
      params.require(:task).permit(:body, :completed, :list_id)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/lists_helper.rb
module ListsHelper
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Lista de Tareas</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <div class="container">
      <%= yield %>
    </div>
  </body>
</html>

app/views/lists/_form.html.erb
<%= form_with(model: list, local: true) do |form| %>
  <% if list.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(list.errors.count, "error") %> prohibited this list from being saved:</h2>

      <ul>
        <% list.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/lists/edit.html.erb
<h1>Editing List</h1>

<%= render 'form', list: @list %>

<%= link_to 'Show', @list %> |
<%= link_to 'Back', lists_path %>

app/views/lists/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Lists</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @lists.each do |list| %>
      <tr>
        <td><%= list.name %></td>
        <td><%= link_to 'Show', list %></td>
        <td><%= link_to 'Edit', edit_list_path(list) %></td>
        <td><%= link_to 'Destroy', list, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New List', new_list_path %>

app/views/lists/new.html.erb
<h1>New List</h1>

<%= render 'form', list: @list %>

<%= link_to 'Back', lists_path %>

app/views/lists/show.html.erb
<p id="notice"><%= notice %></p>

<h2>
  <%= @list.name %>
</h2>
<table>
  <thead>
    <tr>
      <th>Body</th>
    </tr>
  </thead>
  <tbody>
    <% @tasks.each do |task| %>
      <tr>
        <td>
          <% if task.completed? %>
            <strike><%= task.body %></strike>
          <% else %>
            <%= task.body %> <%= link_to "Edit", edit_list_task_path(@list, task) %>
          <% end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>
<%= link_to 'New Task', new_list_task_path(@list) %> |
<%= link_to 'Edit', edit_list_path(@list) %> |
<%= link_to 'Back', lists_path %>

app/views/tasks/_form.html.erb
<%= form_with(model: task, url: [@list, @task], local: true) do |form| %>
  <% if task.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(task.errors.count, "error") %> prohibited this task from being saved:</h2>

      <ul>
        <% task.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :body %>
    <%= form.text_field :body %>
  </div>

  <div class="field">
    <%= form.label :completed %>
    <%= form.check_box :completed %>
  </div>

  <div class="field">
    <%= form.label :list_id %>
    <%= form.text_field :list_id %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/tasks/edit.html.erb
<h1>Editing Task</h1>

<%= render 'form', task: @task %>

<%= link_to 'Back', list_tasks_path %>

app/views/tasks/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Tasks</h1>

<table>
  <thead>
    <tr>
      <th>Body</th>
      <th>Completed</th>
      <th>List</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @tasks.each do |task| %>
      <tr>
        <td><%= task.body %></td>
        <td><%= task.completed %></td>
        <td><%= task.list_id %></td>
        <td><%= link_to 'Show', task %></td>
        <td><%= link_to 'Edit', edit_list_task_path(task) %></td>
        <td><%= link_to 'Destroy', task, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Task', new_task_path %>

app/views/tasks/new.html.erb
<h1>New Task</h1>

<%= render 'form', task: @task %>

<%= link_to 'Back', list_tasks_path %>

app/views/tasks/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Body:</strong>
  <%= @task.body %>
</p>

<p>
  <strong>Completed:</strong>
  <%= @task.completed %>
</p>

<p>
  <strong>List:</strong>
  <%= @task.list_id %>
</p>

<%= link_to 'Edit', edit_list_task_path(@task) %> |
<%= link_to 'Back', list_tasks_path %>